# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'

%define _with_repolib 1
%define _without_sf_plugins 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jaxen/1.1-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

# If you don't want the manual to be built, give rpmbuild option '--without manual'
%define with_manual %{!?_without_manual:1}%{?_without_manual:0}
%define without_manual %{?_without_manual:1}%{!?_without_manual:0}

# Specify --without sf_plugins to build wihout them
%define with_sf_plugins %{!?_without_sf_plugins:1}%{?_without_sf_plugins:0}
%define without_sf_plugins %{?_without_sf_plugins:1}%{!?_without_sf_plugins:0}

%define section	free

Name:		jaxen
Version:	1.1
Release:	1jpp.ep1.4%{?dist}.2
Epoch:		0
Summary:        An XPath engine written in Java
License:        Open Source
Url:            http://jaxen.codehaus.org/
Group:          Development/Libraries/Java
Source0:        http://dist.codehaus.org/jaxen/distributions/jaxen-1.1-src.tar.gz
Source1:        pom-maven2jpp-mapdeps.xsl
Source2:        %{name}-%{version}-jpp-depmap.xml
Source3:        %{name}-%{version}-jpp-disable-mojo-depmap.xml
Source4:        %{name}-%{version}-build.xml
Source5:	jaxen-component-info.xml

Patch1:			jaxen-rhel4-deps.patch
Patch2:         %{name}-%{version}-fix-css-path.patch
Patch3:         %{name}-%{version}-disable-mojo-plugins.patch

Requires:	dom4j >= 0:1.6.1
Requires:	jdom >= 0:1.0-0.rc1.1jpp
Requires:	xalan-j2
Requires:	xerces-j2
Requires:	xom
BuildRequires:  ant >= 0:1.6
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  junit
%if %{with_maven}
BuildRequires:  maven >= 0:1.1
BuildRequires:	maven-plugins-base >= 0:1.1
BuildRequires:	maven-plugin-changes >= 0:1.1
BuildRequires:	maven-plugin-file-activity >= 0:1.1
BuildRequires:	maven-plugin-developer-activity >= 0:1.1
BuildRequires:	maven-plugin-license >= 0:1.1
BuildRequires:	maven-plugin-jdepend >= 0:1.1
BuildRequires:	maven-plugin-tasklist >= 0:1.1
BuildRequires:	maven-plugin-test >= 0:1.1
BuildRequires:	maven-plugin-xdoc >= 0:1.1
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:	xml-commons-apis
%if %{with_sf_plugins}
BuildRequires:  sf-cobertura-maven-plugin
BuildRequires:  sf-findbugs-maven-plugin
%endif
%endif
BuildRequires:	dom4j >= 0:1.6.1
BuildRequires:	jdom >= 0:1.0-0.rc1.1jpp
BuildRequires:	xalan-j2
BuildRequires:	xerces-j2
BuildRequires:	xom
Provides:	jaxen-bootstrap
Obsoletes:	jaxen-bootstrap
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Jaxen is an XPath engine written in Java to work against a variety of XML
based object models such as DOM, dom4j and JDOM together with Java
Beans.

%if %{with_maven}
%if %{with_manual}
%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package manual
Summary:	Documents for %{name}
Group:		Development/Documentation

%description manual
%{summary}.
%endif
%endif

%package demo
Summary:	Samples for %{name}
Group:		Development/Documentation
Requires:	jaxen = 0:%{version}-%{release}

%description demo
%{summary}.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
%{summary}.

%prep
cat <<EOT

                If you dont want to build with maven,
                give rpmbuild option '--without maven'

                If you dont want the manual to be built,
                give rpmbuild option '--without manual'

EOT

rm -rf $RPM_BUILD_ROOT
%setup -q -n %{name}-%{version}
find . -name "*.jar" -exec rm -f {} \;
cp %{SOURCE4} build.xml

%patch1 -b .sav
%patch2 -b .sav

%if %{without_sf_plugins}
%patch3 -b .sav
%endif


tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE5}

%build
%if %{with_maven}
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE1} map=%{SOURCE2}
    popd
done

%if %{without_sf_plugins}
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE1} map=%{SOURCE3}
    popd
done
%endif

mkdir .maven

%if %{with_manual}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$(pwd)/.maven \
        jar javadoc xdoc
%else
maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$(pwd)/.maven \
        jar javadoc
%endif
%else
ant jar javadoc
%endif


%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/jaxen-1.1.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/docs/apidocs
%else
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %{with_maven}
%if %{with_manual}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif
%endif

# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/samples
cp -pr src/java/samples/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/samples


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/jaxen.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
ln -sf %{name}-%{version} %{_javadocdir}/%{name}
 
%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*

%if %{with_maven}
%if %{with_manual}
%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}
%endif
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Thu Aug 02 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.1-1jpp.ep1.4.2
- Rebuild

* Thu Jul 26 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.1-1jpp.ep1.4.1
- Rebuild with JDK 1.4

* Thu Jul 12 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.1-1jpp.ep1.4
- Rebuild

* Tue Jul 10 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.1-1jpp.ep1.3
- Adjust JAXP API location for RHEL5 Base version of xml-commons

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.1-1jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.1-1jpp.ep1.1
- Rebuild

* Mon Feb 19 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.1-1jpp.el4ep1.1
- Add repolib support

* Sat Feb 17 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.1-1jpp
- Upgrade to 1.1 final
- Updated xsl sheet
- Updated ant build file
- Removed un-necessary saxon transforms
- Fixed BuildRequires and Requires
- Fixed javadoc creation
- Added an option to not use sf plugins

* Sun Feb 26 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.1-0.b7.4jpp
- Rebuild for JPP 1.7

* Wed Feb 15 2006 Ralph Apel <r.apel@r-apel.de> 0:1.1-0.b7.3jpp
- Insert Copyright notice

* Mon Feb 13 2006 Ralph Apel <r.apel@r-apel.de> 0:1.1-0.b7.2jpp
- Adapt to maven-1.1
- Create option to build without maven

* Wed Aug 17 2005 Ralph Apel <r.apel@r-apel.de> 0:1.1-0.b7.1jpp
- Upgrade to 1.1-beta-7
- Now mavenized
- Requiring dom4j >= 1.6.1
- rpmbuild option to inhibit build of manual (needs newer maven)

* Thu Sep 09 2004 Ralph Apel <r.apel@r-apel.de> 0:1.1-0.b2.1jpp
- Upgrade to 1.1-beta-2
- Drop saxpath requirement as saxpath is now included in jaxen

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0-4jpp
- Rebuild with ant-1.6.2
* Mon Jan 19 2004 Ralph Apel <r.apel@r-apel.de> 0:1.0-3jpp
- build against dom4j-1.4-1jpp
- introduce manual and demo subpackages
- patch org.jaxen.dom4j.DocumentNavigatorTest
- include LICENSE in main package
- run tests during build

* Thu Jan 15 2004 Ralph Apel <r.apel@r-apel.de> 0:1.0-2jpp
- activate support for dom4j by renaming lib/dom4j-core.jar to .zip

* Sun May 04 2003 David Walluck <david@anti-microsoft.org> 0:1.0-1jpp
- release
